#ifndef include
extern int fprintf();
extern int fread();
extern int fwrite();
extern int fscanf();
extern void fclose();
extern int fgetc();
extern int fputc();
extern int printf();
#endif

#define RLK                     (1L << 0)
#define EGENGETPUT		(1L << 1)
#define FSCANFPRINTF		(1L << 2)
#define FREADFWRITE             (1L << 3)

#define Fgetint(i,s,t)   for((i)=0,t=3;t>=0;t--) (i)+=(fgetc(s)<<(t*8))
#define Fputint(i,s,t)   for(t=3;t>=0;t--) fputc((char)(((i)>>(t*8))&255),s)

/* Loader inn en run-length kodet fil og returnerer den som et buffer */
char *load(FILE *fra,int *x,int *y,long flags)
{
  int t,tot;
  unsigned char ant;
  char *buffer,kode;

  if (flags&EGENGETPUT)
    {
      Fgetint(*x,fra,t);
      Fgetint(*y,fra,t);
    }

  if (flags&FSCANFPRINTF) fscanf(fra,"%d %d",x,y);
    
  if (flags&FREADFWRITE) 
    {
      fread((char *)x,sizeof(*x),1,fra);
      fread((char *)y,sizeof(*x),1,fra);
    }
  
  buffer=(char *)malloc((*x)*(*y));
  t=0;
  tot=(*x)*(*y);
  
  if (!(flags&RLK)) 
    {
      fread(buffer,sizeof(char),tot,fra);
      return(buffer);
    }
  
  do
    {
      fread((char *)&ant,sizeof(ant),1,fra);
      fread((char *)&kode,sizeof(kode),1,fra);
      for(;(ant);ant--) buffer[t++]=kode;
      if(t<tot)
        {
          fread((char *)&ant,sizeof(ant),1,fra);
          fread((char *)&buffer[t],sizeof(*buffer),(int)ant,fra);
          t+=(int)ant;
        }
    }
  while(tot>t);
  if (tot!=t) fprintf(stderr,"Feil i innput fra fil\n");
  fclose(fra);
  return(buffer);
}

void save(FILE *til,char *buffer,int x,int y,long flags)
{
  int t,tot,max=255;
  unsigned char ant;
  char kode;

  if (flags&EGENGETPUT)
    {
      Fputint(x,til,t);
      Fputint(y,til,t);
    }

  if (flags&FSCANFPRINTF) fprintf(til,"%d %d",x,y);
    
  if (flags&FREADFWRITE)
    {
      fwrite((char *)&x,sizeof(x),1,til);
      fwrite((char *)&y,sizeof(y),1,til);
    }
  
  t=0;
  tot=x*y;

  if (!(flags&RLK)) fwrite(buffer,sizeof(char),tot,til);
  else do
    {
      ant=0;
      if (t+max>tot) max=tot-t;
      kode=buffer[t];
      do
        ant+=1;
      while((buffer[t+(int)ant]==kode)&&(ant<max));
      fwrite((char *)&ant,sizeof(ant),1,til);
      fwrite((char *)&kode,sizeof(kode),1,til);
      t+=(int)ant;
      
      if (t<tot)
        {
          ant=0;
          if (t+max>tot) max=tot-t;
          do
            ant+=1;
          while((buffer[t+(int)ant-1]!=buffer[t+(int)ant])&&(ant!=255));
          fwrite((char *)&ant,sizeof(ant),1,til);
          fwrite((char *)&buffer[t],sizeof(*buffer),ant,til);
          t+=(int)ant;
        }
    }
  while(t<tot);
}
